/* 14 May 92. fixopt.c. Cleans up the .opt files 
   uses standard input and output */

#include <stdio.h>

main()
{
  float psi,rho,lpsi,lrho,psum,rsum;
  int i,tmp,date;
  char s[12];

  i = 1;
  lpsi = 0.0; lrho = 0.0;
  psum = 0.0; rsum = 0.0;
  while (scanf("%i %i %f %f",&tmp,&date,&psi,&rho) != EOF)
    {
      if (psi < 0.0) psi = 0.5*lpsi;
      if (rho < -1.0) rho = 0.5*(lrho - 1.0);
      if (rho > 1.0) rho = 0.5*(lrho + 1.0);
      printf("%i  %i  %f  %f\n",i,date,psi,rho);
      rsum += rho; psum += psi;
      lrho = rho; lpsi = psi;
      i++;
    }
  psum = psum/(i - 1.0); rsum = rsum/(i - 1.0);
  fprintf(stderr,"All done! avg psi, rho = %f, %f\n",psum,rsum);
}
